//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "potomne.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormPotomne *FormPotomne;
//---------------------------------------------------------------------------
__fastcall TFormPotomne::TFormPotomne(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormPotomne::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TFormPotomne::RedukcjaSrednia(void)
{
    // szybszy sposob, ale zalezny od reprezentacji bitmapy
    Byte *ptr;
    for (int y = 0; y < Image1->Picture->Bitmap->Height; y++)
    {
      ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[y];

      for (int x = 0; x < Image1->Picture->Bitmap->Width; x++)
      {
        int iSrednia = (ptr[x*3]+ptr[x*3+1]+ptr[x*3+2])/3; // BGR
        ptr[x*3] = iSrednia;
        ptr[x*3+1] = iSrednia;
        ptr[x*3+2] = iSrednia;
      }
    }
/*
    // wolniejszy sposob, ale dziala dla roznego rodzaju bitmap
    TColor KolorPunktu;
    for (int y = 0; y < Image1->Height; y++)
      for (int x = 0; x < Image1->Width; x++)
      {
        KolorPunktu = Image1->Canvas->Pixels[x][y];
        int iSrednia = (GetRValue(KolorPunktu)+GetGValue(KolorPunktu)+GetBValue(KolorPunktu))/3;
        Image1->Canvas->Pixels[x][y] = (TColor)(iSrednia + (iSrednia<<8) + (iSrednia<<16));
      }
*/
}
//---------------------------------------------------------------------------
void __fastcall TFormPotomne::RedukcjaSredniaWazona(void)
{
    // szybszy sposob, ale zalezny od reprezentacji bitmapy
    Byte *ptr;
    for (int y = 0; y < Image1->Picture->Bitmap->Height; y++)
    {
      ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[y];

      for (int x = 0; x < Image1->Picture->Bitmap->Width; x++)
      {
        int iSrednia = 0.114*(double)ptr[x*3]+0.587*(double)ptr[x*3+1]+0.299*(double)ptr[x*3+2]; // BGR
        ptr[x*3] = iSrednia;
        ptr[x*3+1] = iSrednia;
        ptr[x*3+2] = iSrednia;
      }
    }

/*    // wolniejszy sposob, ale dziala dla roznego rodzaju bitmap
    TColor KolorPunktu;
    for (int y = 0; y < Image1->Height; y++)
      for (int x = 0; x < Image1->Width; x++)
      {
        KolorPunktu = Image1->Canvas->Pixels[x][y];
        int iSrednia = (0.299*(double)GetRValue(KolorPunktu)+0.587*(double)GetGValue(KolorPunktu)+0.114*(double)GetBValue(KolorPunktu));
        Image1->Canvas->Pixels[x][y] = (TColor)(iSrednia + (iSrednia<<8) + (iSrednia<<16));
      }
*/
}
//---------------------------------------------------------------------------
void __fastcall TFormPotomne::Redukcja16Rownomierna(void)
{
    // szybszy sposob, ale zalezny od reprezentacji bitmapy
    Byte *ptr;
    for (int y = 0; y < Image1->Picture->Bitmap->Height; y++)
    {
      ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[y];

      for (int x = 0; x < Image1->Picture->Bitmap->Width; x++)
      {
        int iSrednia = ((int)(0.114*(double)ptr[x*3]+0.587*(double)ptr[x*3+1]+0.299*(double)ptr[x*3+2])/17)*17; // BGR
        ptr[x*3] = iSrednia;
        ptr[x*3+1] = iSrednia;
        ptr[x*3+2] = iSrednia;
      }
    }

/*    // wolniejszy sposob, ale dziala dla roznego rodzaju bitmap
    TColor KolorPunktu;
    for (int y = 0; y < Image1->Height; y++)
      for (int x = 0; x < Image1->Width; x++)
      {
        KolorPunktu = Image1->Canvas->Pixels[x][y];
        int iSrednia = ((int)((0.299*(double)GetRValue(KolorPunktu)+0.587*(double)GetGValue(KolorPunktu)+0.114*(double)GetBValue(KolorPunktu))/17))*17;
        Image1->Canvas->Pixels[x][y] = (TColor)(iSrednia + (iSrednia<<8) + (iSrednia<<16));
      }
*/
}
//---------------------------------------------------------------------------
void __fastcall TFormPotomne::Redukcja16Mediana(void)
{
    int Histogram[256];
    Byte *ptr;

    // sortowanie przez zliczanie
    TColor KolorPunktu;
    memset( &Histogram, 0, sizeof(Histogram) );
    for(int y = 0; y < Image1->Picture->Bitmap->Height; y++)
    {
      ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[y];
      for(int x = 0; x < Image1->Picture->Bitmap->Width; x++)
      {
        int iSrednia = 0.114*(double)ptr[x*3]+0.587*(double)ptr[x*3+1]+0.299*(double)ptr[x*3+2]; // BGR
        Histogram[iSrednia]++;
      }
    }

    unsigned char *pPosortowane = new unsigned char[Image1->Height*Image1->Width];
    memset( pPosortowane, 0, sizeof( *pPosortowane ) );
    int i=0;
    for( int iHistogram=0; iHistogram<256; iHistogram++ )
        for( int iIlosc=0; iIlosc<Histogram[iHistogram]; iIlosc++ )
            pPosortowane[i++] = iHistogram;

    // oblicz kolory palety
    int iPunktowNaOdcien = Image1->Height*Image1->Width / 16;
    for( int iOdcien=0; iOdcien<16; iOdcien++ )
    {
        int iSuma = 0;
        for( int iPunkt=0; iPunkt<iPunktowNaOdcien; iPunkt++ )
            iSuma += pPosortowane[iOdcien*iPunktowNaOdcien+iPunkt];
        int iSzarosc = iSuma/iPunktowNaOdcien;
        // zamien piksele obrazu wedlug palety
        for(int y = 0; y < Image1->Picture->Bitmap->Height; y++)
        {
            ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[y];
            for(int x = 0; x < Image1->Picture->Bitmap->Width; x++)
            {
                int iSrednia = 0.114*(double)ptr[x*3]+0.587*(double)ptr[x*3+1]+0.299*(double)ptr[x*3+2]; // BGR
                if( iSrednia<=pPosortowane[(iOdcien+1)*iPunktowNaOdcien-1]
                 && iSrednia>pPosortowane[iOdcien*iPunktowNaOdcien])
                {
                    ptr[x*3] = iSzarosc;
                    ptr[x*3+1] = iSzarosc;
                    ptr[x*3+2] = iSzarosc;
                }
            }
        }
    }

    delete[] pPosortowane;
}
//---------------------------------------------------------------------------

